import 'package:flutter/material.dart';
import 'package:hub/shared/components/molecules/menu/index.dart';

enum MenuItem {
  button,
  card,
  tile;

  MenuEntry getInstance(final Function() action, final String title, final IconData icon) {
    switch (this) {
      case MenuItem.button:
        return MenuButtonWidget(action: action, title: title, icon: icon);
      case MenuItem.card:
        return MenuCardItem(action: action, title: title, icon: icon);
      case MenuItem.tile:
        return MenuCardItem(action: action, title: title, icon: icon);
    }
  }
}

abstract class MenuEntry extends StatefulWidget {
  const MenuEntry({
    super.key,
    required this.action,
    required this.title,
    required this.icon,
  });

  final Function() action;
  final String title;
  final IconData icon;

  factory MenuEntry.create(
    MenuItem type, {
    Key? key,
    required Function() action,
    required String title,
    required IconData icon,
  }) {
    return type.getInstance(action, title, icon);
  }
}
